#define sis_version	2.02
//update list
//2002.5.23 add memcpy
//2002.8.27 mark audio and add netdev
/*******************************define value*******************************/
//#define sunburst_kernel_lock

#define _LOOSE_KERNEL_NAMES
//fixme #undef smp_num_cpus
//fixme #undef smp_message_pass

/*******************************include header******************************/
#include <linux/modversions.h>
#include <linux/config.h>
#include <linux/version.h>
#include <linux/ac97_codec.h>
#include <stdarg.h>

#ifdef sunburst_kernel_lock
#include <asm/spinlock.h>
#endif

#include <linux/module.h>
#include <linux/param.h>
#include <linux/types.h>
#include <linux/errno.h>
#include <linux/signal.h>
#include <linux/fcntl.h>
#include <linux/sched.h>
#include <linux/timer.h>
#include <linux/tty.h>
#include <linux/mm.h>
#include <linux/ctype.h>
#include <linux/delay.h>

#if LINUX_VERSION_CODE >= 132096 /* 2.4.x */
#include <asm/processor.h>
#endif

#include <linux/slab.h>
#include <linux/vmalloc.h>
#include <asm/io.h>
#include <linux/pci.h>
#include <linux/apm_bios.h>
#include <asm/segment.h>
#include <linux/tqueue.h>
#include <asm/div64.h>

#if LINUX_VERSION_CODE > 131328	/* 2.1.x */

#include <asm/uaccess.h>
#include <linux/poll.h>
#include <linux/wireless.h>
static char kernel_version[32] = UTS_RELEASE;

#else
#include <linux/bios32.h>
#endif
#include <asm/system.h>
#include <asm/dma.h>
#if LINUX_VERSION_CODE < 131097
#include <sys/kd.h>
#endif

#include <linux/wait.h>
#include <linux/malloc.h>
#include <linux/string.h>
#include <linux/ioport.h>
#include <linux/interrupt.h>
#include <linux/tqueue.h>
//#include <linux/spinlock.h>

#if LINUX_VERSION_CODE>=132095
#include <linux/pm.h>
#endif

#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/skbuff.h>
#include <linux/if.h>
#include <pcmcia/driver_ops.h>

#include "wrap.h"

struct sistq {
	void (*routine)(void*);
	void *data;
};
static struct tq_struct sis_bh;

static struct net_device_stats sis_status;//

static struct pci_driver * pcidvr;
static struct file_operations *mixerfop;
static struct file_operations *audiofop;
#define	MAX_SIS160_COUNT 0x8
static struct driver_operations *driver_op[MAX_SIS160_COUNT];
static	int	netcard_index = 0;


typedef dev_node_t * (*driver_operations_attach_t) (dev_locator_t *loc);
typedef void (*driver_operations_suspend_t) (dev_node_t *dev);
typedef void (*driver_operations_resume_t) (dev_node_t *dev);
typedef void (*driver_operations_detach_t) (dev_node_t *dev);

typedef u16 (*ac97_read_t) (struct ac97_codec *,u8);
typedef void (*ac97_write_t) (struct ac97_codec *,u8,u16);
typedef int (*probe_t) (struct pci_dev *,const struct pci_device_id *);
typedef void (*remove_t) (struct pci_dev *);
typedef int (*suspend_t) (struct pci_dev *,u32);
typedef int (*resume_t) (struct pci_dev *);

typedef	int	(*netdev_open_t)(struct net_device *);
typedef	int	(*netdev_stop_t)(struct net_device *dev);
typedef int	(*netdev_hard_start_xmit_t) (struct sk_buff *skb,
						    struct net_device *dev);
typedef void (*netdev_set_multicast_list_t)(struct net_device *dev);
typedef	int	(*netdev_set_mac_address_t)(struct net_device *dev,
						   void *addr);
typedef	int	(*netdev_do_ioctl_t)(struct net_device *dev,
					    struct ifreq *ifr, int cmd);
typedef	int	(*netdev_change_mtu_t)(struct net_device *dev, int new_mtu);
typedef	struct net_device_stats* (*netdev_get_stats_t)(struct net_device *dev);
typedef	struct iw_statistics*	(*netdev_get_wireless_stats_t)(struct net_device *dev);

/*
 * These typedefs must match definition of struct file_operations.
 * (See notes in routine module_register_chrdev).
 */

#if LINUX_VERSION_CODE > 131328	/* 2.1.x */
typedef long long (*llseek_t) (struct inode *, struct file *, long long, int);
typedef ssize_t (*read_t) (struct file *, char *, size_t, loff_t *);
typedef ssize_t (*write_t) (struct file *, const char *, size_t, loff_t *);
typedef unsigned int (*poll_t) (struct file *, poll_table *);
typedef poll_table select_table;
#else
typedef int (*lseek_t) (struct inode *, struct file *, off_t, int);
typedef int (*read_t) (struct inode *, struct file *, char *, int);
typedef int (*write_t) (struct inode *, struct file *, const char *, int);
typedef int (*select_t) (struct inode *, struct file *, int, select_table *);
#endif

typedef int (*readdir_t) (struct inode *, struct file *, void *, filldir_t);
typedef int (*ioctl_t) (struct inode *, struct file *, unsigned int,
						unsigned long);

#if LINUX_VERSION_CODE >= 131359	/* 2.1.31 */
typedef int (*mmap_t) (struct file *, struct vm_area_struct *);
#else
typedef int (*mmap_t) (struct inode *, struct file *,
					   struct vm_area_struct *);
#endif

typedef int (*open_t) (struct inode *, struct file *);

#if LINUX_VERSION_CODE >= 131359	/* 2.1.31 */
typedef int (*release_t) (struct inode *, struct file *);
typedef int (*fasync_t) (int, struct file *, int);
#else
typedef void (*release_t) (struct inode *, struct file *);
typedef int (*fasync_t) (struct inode *, struct file *, int);
#endif

typedef int (*fsync_t) (struct inode *, struct file *);

#if LINUX_VERSION_CODE<131858	/* Prior 2.3.x */
typedef int (*check_media_change_t) (kdev_t dev);
typedef int (*revalidate_t) (kdev_t dev);
#else
#define MAX_KMALLOCS 1024
//static int nr_kmallocs = 0;
//static void *kmallocs[MAX_KMALLOCS];
#endif

extern int sis160_init_module(void);
extern void sis160_cleanup_module(void);

#if LINUX_VERSION_CODE > 131328	/* 2.1.x */
static loff_t
no_llseek (struct file *file, loff_t offset, int orig)
{
	return -EINVAL;
}

#ifndef MAP_NR
/* 2.4.0-test6 or later */
static int
no_fsync (struct file *f, struct dentry *d, int datasync)
{
	return -EINVAL;
}
#else
static int
no_fsync (struct file *f, struct dentry *d)
{
	return -EINVAL;
}
#endif

static int
no_fasync (int x, struct file *f, int m)
{
	return -EINVAL;
}
#endif

static struct driver_operations *
alloc_driver_operations(struct driver_operations_handle *dop)
{
	struct driver_operations *dvrop;
	driver_operations_attach_t tmp_attach = (driver_operations_attach_t) dop->attach;
	driver_operations_suspend_t tmp_suspend = (driver_operations_suspend_t) dop->suspend;
	driver_operations_resume_t tmp_resume = (driver_operations_resume_t) dop->resume;
	driver_operations_detach_t tmp_detach = (driver_operations_detach_t) dop->detach;
	if(netcard_index<MAX_SIS160_COUNT)
	{
		dvrop = kmalloc(sizeof(struct driver_operations),GFP_KERNEL);
		memset(dvrop,0,sizeof(struct driver_operations));
		dvrop->name = dop->name;
		dvrop->attach = tmp_attach;
		dvrop->suspend = tmp_suspend;
		dvrop->resume = tmp_resume;
		dvrop->detach = tmp_detach;
		driver_op[netcard_index] = dvrop;
		netcard_index++;
	}
	else
	{
		//printk("ERROR : Too Much SiS160 Card\n");
		return NULL;
	}
	return (dvrop);
}

////////////////////////////////////////////////////////////////////////////
//	Function : alloc_pci_driver
//	Description :
//		Allocate a struct pci_driver,return it to register pci_driver
//	Input :
//		dp
//	Return :
//		a struct pci_driver item which is transformed from dp
////////////////////////////////////////////////////////////////////////////
static struct pci_driver *
alloc_pci_driver(struct pci_driver_handle *dp)
{
	struct pci_driver *pdvr;
        char *tmp_name = dp->name;
        const struct pci_device_id *tmp_id_table = dp->id_table;
        probe_t tmp_probe = (probe_t) dp->probe;
        remove_t tmp_remove = (remove_t) dp->remove;
#ifdef CONFIG_PM
		suspend_t tmp_suspend = (suspend_t) dp->suspend;
		resume_t tmp_resume = (resume_t) dp->resume;
#endif
	pdvr = (struct pci_driver *)
	kmalloc (sizeof (struct pci_driver), GFP_KERNEL);

	memset ((char *) pdvr, 0, sizeof (struct pci_driver));
  	pdvr->name = tmp_name;
  	pdvr->id_table = tmp_id_table;
  	pdvr->probe = tmp_probe;
  	pdvr->remove = tmp_remove;
#ifdef CONFIG_PM
	pdvr->suspend = tmp_suspend;
	pdvr->resume = tmp_resume;
#endif
  	pcidvr = pdvr;
  	return pdvr;

}
/////////////////////////////////////////////////////////////////////////////
//	Function:	alloc_fop
//	Description:
//		Allocate a structure file_operations, return it to register
//		device
//	Parameters:
//		op:
//		tmpfop: used to kfree item when unregister device
//	Return :
//		A struct file_operations which is transformed from op
////////////////////////////////////////////////////////////////////////////
static struct file_operations *
alloc_fop (struct file_operation_handle *op,struct file_operations *tmpfop)
{
  struct file_operations *fop;
#if LINUX_VERSION_CODE >=132096
  struct module *tmp_owner = (struct module *) op->owner;
#endif

#if LINUX_VERSION_CODE <= 131328	/* 2.1.x */
  lseek_t tmp_lseek = (lseek_t) op->lseek;
  select_t tmp_select = (select_t) op->select;
  fsync_t tmp_fsync = (fsync_t) op->fsync;
  fasync_t tmp_fasync = (fasync_t) op->fasync;
#else
  poll_t tmp_poll = (poll_t) op->poll;
#endif
  read_t tmp_read = (read_t) op->read;
  write_t tmp_write = (write_t) op->write;
  /* readdir_t tmp_readdir = (readdir_t)op->readdir; */
  ioctl_t tmp_ioctl = (ioctl_t) op->ioctl;
  mmap_t tmp_mmap = (mmap_t) op->mmap;
  open_t tmp_open = (open_t) op->open;
  release_t tmp_release = (release_t) op->release;
#if LINUX_VERSION_CODE<131858	/* Prior 2.3.x */
  check_media_change_t tmp_check_media_change =
	(check_media_change_t) op->check_media_change;
  revalidate_t tmp_revalidate = (revalidate_t) op->revalidate;
#endif

	fop = (struct file_operations *)
		kmalloc (sizeof (struct file_operations), GFP_KERNEL);

	memset ((char *) fop, 0, sizeof (struct file_operations));

/*
 *	Now the assignment
 */
#if LINUX_VERSION_CODE >=132096
	fop->owner = tmp_owner;
#endif

#if LINUX_VERSION_CODE > 131328	/* 2.1.x */
	fop->llseek = no_llseek;
#else
	fop->lseek = tmp_lseek;
#endif
	fop->read = tmp_read;
	fop->write = tmp_write;
	fop->readdir = NULL;			/* tmp_readdir; */
#if LINUX_VERSION_CODE > 131328	/* 2.1.x */
	fop->poll = tmp_poll;
#else
	fop->select = tmp_select;
#endif
	fop->ioctl = tmp_ioctl;
	fop->mmap = tmp_mmap;
	fop->open = tmp_open;
	fop->release = tmp_release;
#if LINUX_VERSION_CODE > 131328	/* 2.1.x */
	fop->fsync = no_fsync;
	fop->fasync = no_fasync;
#else
	fop->fsync = tmp_fsync;
	fop->fasync = tmp_fasync;
#endif
#if LINUX_VERSION_CODE<131858	/* Prior 2.3.x */
	fop->check_media_change = tmp_check_media_change;
	fop->revalidate = tmp_revalidate;
#else
	fop->lock = NULL;
	fop->flush = NULL;
#endif
	tmpfop = fop;
	return fop;
}

////////////////////////////////////////////////////////////////////////////
//	Function : struct file access routines.
//	Description :
//		Routines used for seting/geting member from struct file
//	Parameters :
//
//	Return :
//		get : the member in struct file
//		set : none
////////////////////////////////////////////////////////////////////////////
mode_t
file_get_mode(file_handle * file)
{
	return ((struct file *) file)->f_mode;
}
int
file_get_flags (file_handle * file)
{
	return ((struct file *) file)->f_flags;
}
loff_t *
file_get_f_pos(file_handle * file)
{
	return &((struct file *) file)->f_pos;
}
void *
file_get_private (file_handle * file)
{
	return ((struct file *) file)->private_data;
}
void
file_set_flags (file_handle * file, int flags)
{
	((struct file *) file)->f_flags |= flags;
}
void
file_set_private (file_handle * file, void *v)
{
	((struct file *) file)->private_data = v;
}

#if LINUX_VERSION_CODE > 131328	/* 2.1.x */
dentry_handle *
file_get_dentry (file_handle * file)
{
	return (dentry_handle *) dget (((struct file *) file)->f_dentry);
}

inode_handle * dentry_get_inode (dentry_handle * d)
{
	return (inode_handle *) ((struct dentry *) d)->d_inode;
}
#endif

inode_handle *
file_get_inode (file_handle * file)
{
#if LINUX_VERSION_CODE > 131328	/* 2.1.x */
  if (((struct file *) file)->f_dentry == NULL ||
	  ((struct file *) file)->f_dentry->d_inode == NULL)
	panic ("sndobj: file_get_inode called for bad file\n");
  return (inode_handle *) ((struct file *) file)->f_dentry->d_inode;
#else
  return (inode_handle *) ((struct file *) file)->f_inode;
#endif
}
////////////////////////////////////////////////////////////////////////////
//	Function : vm_area_struct access routines
//	Description :
//		Routines used for seting/geting member from struct vm_area_struct
//	Parameters :
//
//	Return :
//		get : the member in struct vm_area_struct
//		set : none
////////////////////////////////////////////////////////////////////////////

#if LINUX_VERSION_CODE<131858	/* Prior 2.3.x */
#if LINUX_VERSION_CODE > 131328	/* 2.1.x */
void
vma_mmap_file (vm_area_handle * vma, file_handle * file)
{
	((struct vm_area_struct *) vma)->vm_file = (struct file *) file;
	((struct file *) file)->f_count++;
}
#else
void
vma_set_inode (vm_area_handle * vma, inode_handle * inode)
{
	((struct vm_area_struct *) vma)->vm_inode = (struct inode *) inode;
}
#endif
#endif

int
vma_get_flags (vm_area_handle * vma)
{
	return ((struct vm_area_struct *) vma)->vm_flags;
}

unsigned long
vma_get_offset (vm_area_handle * vma)
{
#if LINUX_VERSION_CODE<131858	/* Prior 2.3.x */
	return ((struct vm_area_struct *) vma)->vm_offset;
#else
	return ((struct vm_area_struct *) vma)->vm_pgoff;
#endif
}

unsigned long
vma_get_start (vm_area_handle * vma)
{
	return ((struct vm_area_struct *) vma)->vm_start;
}

unsigned long
vma_get_end (vm_area_handle * vma)
{
	return ((struct vm_area_struct *) vma)->vm_end;
}

pgprot_t vma_get_page_prot (vm_area_handle * vma)
{
	return ((struct vm_area_struct *) vma)->vm_page_prot;
}

/**********************************global variable**********************************/

static int wrapper_initialized = 1;


/**********************************export symbol**************************************/
/* EXPORT_SYMBOL from sound_core.c */
//extern int register_sound_mixer(struct file_operations *,int);
//extern int register_sound_dsp(struct file_operations *,int);
//extern int register_sound_special(struct file_operations *,int);
//extern int register_sound_midi(struct file_operations *,int);
//extern int register_sound_synth(struct file_operations *,int);
//extern void unregister_sound_special(int);
//extern void unregister_sound_mixer(int);
//extern void unregister_sound_midi(int);
//extern void unregister_sound_dsp(int);
//extern void unregister_sound_synth(int);

/* EXPORT_SYMBOL from ac97_codec.c */
//extern int ac97_read_proc(char *,char **,off_t,int,int *,void *);
//extern int ac97_probe_codec(struct ac97_codec *);

#ifdef sunburst_kernel_lock
extern void kernel_lock(void);
extern void kernel_unlock(void);
#endif

/**********************************function************************************/

/**********************************ac97_codec routine*********************/

#if LINUX_VERSION_CODE >= 132106
//unsigned int sis_ac97_set_adc_rate(struct ac97_codec *codec, unsigned int rate)
//{
//	return ac97_set_adc_rate(codec,rate);
//}
#else
//unsigned int sis_ac97_set_adc_rate(struct ac97_codec *codec, unsigned int rate)
//{
//	return 0;
//}
#endif

/**********************************version check routine***********************/
int sis_connect(void)
{
//	printk ("version is %d\n",LINUX_VERSION_CODE);
	return (LINUX_VERSION_CODE);
}

/**********************************spin_lock routine***************************/

void sis_spin_unlock(void * lock)
{
	spin_unlock(lock);
}
void sis_spin_lock(void *lock)
{
	spin_lock(lock);
}
void sis_spin_lock_init(void *__lock)
{
	spinlock_t *lock = (spinlock_t *)__lock;
	spin_lock_init(lock);
}
void sis_spin_lock_irqsave(void * lock,unsigned long *flag)
{
	spin_lock_irqsave(lock,*flag);
}

void sis_spin_unlock_irqrestore(void * lock, unsigned long *flag)
{
	spin_unlock_irqrestore(lock,*flag);
}

#ifdef sunburst_kernel_lock
static void sis_lock_kernel(void)
{

	lock_kernel();
}

static void sis_unlock_kernel(void)
{
	unlock_kernel();
}
#endif

/******************************************irq routine************************/
void sis_synchronize_irq(void)
{
	synchronize_irq();
}

int sis_request_irq(unsigned int irq,void (*handler)(int, void *, struct pt_regs *),unsigned long shirq,const char *name,void *devid)
{
	return request_irq(irq,handler,shirq,name,devid);
}

void sis_free_irq(unsigned int irq,void *obj)
{
	free_irq(irq,obj);
}

/******************************************memory management routine**************/
void * sis_memcpy(void *to,void *from,size_t n)
{
	return memcpy(to,from,n);
}
void * sis_memset(void *x,int i,size_t t)
{
	return memset(x,i,t);
}

int sis_remap_page_range(unsigned long from,unsigned long to,unsigned long size,pgprot_t prot)
{
	return remap_page_range(from,to,size,prot);
}
void * sis_get_free_pages(int order)
{
	return (void *)__get_free_pages(GFP_KERNEL | GFP_DMA, order);
}
void sis_free_pages(unsigned long addr,unsigned int order)
{
	free_pages(addr,order);
}
void sis_kfree(void *addr)
{
	kfree(addr);
}

void * sis_kmalloc(unsigned long s, int oldmask)
{
	int mask=0;

	if (oldmask&OSS_GFP_KERNEL)mask|=GFP_KERNEL;
	return kmalloc (s, mask);
}
void sis_mem_map_set(unsigned long map)
{
	set_bit(PG_reserved,&mem_map[map].flags);
}
void sis_mem_map_clear(unsigned long map)
{
	clear_bit(PG_reserved,&mem_map[map].flags);
}
void sis_mem_map_unreserve(struct page *page)
{
	clear_bit(PG_reserved,&(page->flags));
//	return (mem_map_unreserve(page));
}

void sis_mem_map_reserve(struct page *page)
{

	set_bit(PG_reserved,&(page->flags));
//	return (mem_map_reserve(page));
}
void * sis_ioremap (unsigned long offset, unsigned long size)
{
	return ioremap(offset,size);
}
void sis_iounmap(void *addr)
{
	iounmap(addr);
}
#if LINUX_VERSION_CODE >= 132096
struct page  * sis_virt_to_page(char *buf)
{
	return 	virt_to_page(buf);
}
#endif
void
sis_reserve_page(void * rawbuf,unsigned int size)
{
   	struct page *pend,*page;
   	pend = sis_virt_to_page(rawbuf+size);
	for(page=sis_virt_to_page(rawbuf);page<=pend;page++)
		sis_mem_map_reserve(page);

}
void
sis_unreserve_page(void * rawbuf,unsigned int size)
{
   	struct page *pend,*page;
   	pend = sis_virt_to_page(rawbuf+size);
	for(page=sis_virt_to_page(rawbuf);page<=pend;page++)
		sis_mem_map_unreserve(page);

}
/*******************************************ac97_codec routine*****************/
//int sis_ac97_probe_codec(ac97_codec_handle *codec)
//{
//	struct ac97_codec * co = (struct ac97_codec *) codec;
//        return ac97_probe_codec(co);
//}

//int sis_ac97_read_proc(char *page,char **start,off_t off,int count,int *eof,void *data)
//{
// 	return ac97_read_proc(page,start,off,count,eof,data);
//}

/******************************************task routine************************/
void sis_udelay(unsigned long delay)
{
	udelay(delay);
}
void sis_mdelay(unsigned long delay)
{
	mdelay(delay);
}
#if LINUX_VERSION_CODE>=131858
void sis_interruptible_sleep_on_timeout(wait_handle *p,signed long tout)
{
	wait_queue_head_t *w = (wait_queue_head_t *) p;
	if (w == NULL)
	{
	  //printk ("tsleep wait_handle == NULL\n");
	  return;
	}
	interruptible_sleep_on_timeout (w, tout);
}
#else
void sis_interruptible_sleep_on_timeout(wait_handle **p,signed long tout)
{
	struct wait_queue **w = (struct wait_queue **) p;
	if (w == NULL)
	{
	  //printk ("tsleep wait_handle == NULL\n");
	  return;
	}
	interruptible_sleep_on_timeout (w, tout);
}
#endif
void sis_schedule_timeout(signed long timeout)
{
//  	current->state = TASK_INTERRUPTIBLE;
	schedule_timeout(timeout);
}

#if LINUX_VERSION_CODE>=131858
void sis_wake_up (wait_handle * p)
{
	wait_queue_head_t *w = (wait_queue_head_t *) p;
	if (w == NULL)
	{
	  //printk ("wake wait_handle == NULL\n");
	  return;
	}
	wake_up (w);
}
#else
void sis_wake_up (wait_handle ** p)
{
	struct wait_queue **w = (struct wait_queue **) p;
	if (w == NULL)
	{
	 // printk ("wake wait_handle == NULL\n");
	  return;
	}
	wake_up (w);
}
#endif
#if LINUX_VERSION_CODE >= 131858
void sis_add_wait_queue(wait_handle *q,wait_handle *new)
{
	wait_queue_head_t *w;
	wait_queue_t *n;

	w = (wait_queue_head_t *) q;
	n = (wait_queue_t *) new;
	add_wait_queue(w,n);
}
#else
void sis_add_wait_queue(wait_handle **q,wait_handle *new)
{
	struct wait_queue **w;
	struct wait_queue  *n;

	w = (struct wait_queue **) q;
	n = (struct wait_queue *) new;
	add_wait_queue(w,n);
}
#endif
#if LINUX_VERSION_CODE >= 131858
void sis_remove_wait_queue(wait_handle * head, wait_handle * old)
{
	wait_queue_head_t *h;
	wait_queue_t *o;
	h = (wait_queue_head_t *) head;
	o = (wait_queue_t *) old;
	remove_wait_queue(h,o);
}
#else
void sis_remove_wait_queue(wait_handle ** head, wait_handle * old)
{
	struct wait_queue **h;
	struct wait_queue *o;
	h = (struct wait_queue **) head;
	o = (struct wait_queue *) old;
	remove_wait_queue(h,o);
}
#endif

static wait_handle * sis_declare_waitqueue(void)
{
//	DECLARE_WAITQUEUE(wait,current);
	wait_queue_t *wa = (wait_queue_t *)kmalloc(sizeof(wait_queue_t),GFP_KERNEL);
	wa->flags = 0x0;
	wa->task = current;
	wa->task_list.next = NULL;
	wa->task_list.prev = NULL;
#if WAITQUEUE_DEBUG
  	wa->__magic = (long)&(current).__magic;
  	wa->__creator = 0;
#endif
	return ((wait_handle *) wa);
}
static void sis_remove_queue(wait_handle * wait)
{
	wait_queue_t * wa = (wait_queue_t *)wait;
	kfree(wa);
}

void sis_init_waitqueue_head(wait_handle * wait)
{
	wait_queue_head_t *w = (wait_queue_head_t *) wait;
	init_waitqueue_head(w);
}
#if LINUX_VERSION_CODE>=	131858
void	sis_poll_wait (file_handle * filp, wait_handle * wait_address,poll_table_handle * p)
{
	wait_queue_head_t * w = (wait_queue_head_t *) wait_address;
	poll_table *t = (poll_table *) p;
	struct file *fil = (struct file *) filp;

	poll_wait(fil,w,t);

//	return poll_wait(filp,wait_address,p);

}
#else
void	sis_poll_wait (file_handle * filp, wait_handle ** wait_address,poll_table_handle * p)
{
	struct wait_queue ** w = (struct wait_queue **) wait_address;
	poll_table *t = (poll_table *) p;
	struct file *fil = (struct file *) filp;

	poll_wait(fil,w,t);

//	return poll_wait(filp,wait_address,p);

}
#endif
/***********************************io routing**************************/
void sis_request_region(unsigned long start,unsigned long n,const char *name)
{
	request_region(start,n,name);
}

void sis_release_region(unsigned long start,unsigned long range)
{
	return release_region(start,range);
}

int sis_check_region(unsigned long from, unsigned long extent)
{
	return check_region (from, extent);
}

/***********************************user interface routing******************/
unsigned long sis_copy_from_user(void *to,const void *from, unsigned long n)
{
	return copy_from_user(to,from,n);
}
unsigned long sis_copy_to_user(void *to,const void *from, unsigned long n)
{
	return copy_to_user(to,from,n);
}

int sis_printk(const char * fmt)
{
	return printk(fmt);
}
void sis_print_size(unsigned int size,const char *str)
{
	//printk("%s size %x\n",str,size);
}
/******************************pci routine***************************************/
#if LINUX_VERSION_CODE >= 132096
unsigned long sis_pci_resource_start(void *pci_dev,int unit)
{

	return pci_resource_start((struct pci_dev *)pci_dev,unit);
}
#endif
int sis_pci_present(void)
{
	return pci_present();
}
int sis_pcibios_present(void)
{
	return pcibios_present();
}
int sis_pcibios_find_device(unsigned short vendor,unsigned short device,unsigned short index,unsigned char *bus,unsigned char *fun)
{
        return pcibios_find_device(vendor,device,index,bus,fun);
}
int sis_pcibios_find_class(unsigned int index,unsigned short device,unsigned char *bus,unsigned char *fun)
{
        return pcibios_find_class(index,device,bus,fun);
}

int sis_pcibios_write_config_byte(unsigned char bus,unsigned char fun,unsigned char where,unsigned char val)
{
        return pcibios_write_config_byte(bus,fun,where,val);
}
int sis_pcibios_write_config_word(unsigned char bus,unsigned char fun,unsigned char where,unsigned short val)
{
        return pcibios_write_config_word(bus,fun,where,val);
}
int sis_pcibios_write_config_dword(unsigned char bus,unsigned char fun,unsigned char where,unsigned int val)
{
        return pcibios_write_config_dword(bus,fun,where,val);
}
int sis_pcibios_read_config_byte(unsigned char bus,unsigned char fun,unsigned char where,unsigned char *val)
{
        return pcibios_read_config_byte(bus,fun,where,val);
}
int sis_pcibios_read_config_word(unsigned char bus,unsigned char fun,unsigned char where,unsigned short *val)
{
        return pcibios_read_config_word(bus,fun,where,val);
}
int sis_pcibios_read_config_dword(unsigned char bus,unsigned char fun,unsigned char where,unsigned int *val)
{
        return pcibios_read_config_dword(bus,fun,where,val);
}
/*
int sis_pci_set_dma_mask(struct pci_dev *hw,dma_addr_t mask)
{
	return pci_set_dma_mask(hw,mask);
}
*/
#if LINUX_VERSION_CODE >= 132096
int sis_pci_dma_supported(void *hwdev,dma_addr_t mask)
{
	return pci_dma_supported((struct pci_dev *)hwdev,mask);
}

//void sis_pci_unregister_driver(struct pci_driver *drv)
//{
//	pci_unregister_driver(drv);
//}

//int sis_pci_register_driver(struct pci_driver *drv)
//{
//	return pci_register_driver(drv);
//}
int sis_pci_enable_device(void *dev)
{
	return pci_enable_device((struct pci_dev *)dev);
}
// by sunburst 2002/3/19 with 70196.c, try to trans pci_dev and pci_driver
void * sis_pci_alloc_consistent(void *hwdev,size_t size,dma_addr_handle *dmahandle)
{
	struct pci_dev *hw = (struct pci_dev *) hwdev;
	return pci_alloc_consistent(hw,size,(dma_addr_t *)dmahandle);
}

void sis_pci_free_consistent(void *hwdev,size_t size,void *vaddr,dma_addr_handle *dmahandle)
{
	struct pci_dev *hw = (struct pci_dev *) hwdev;
	dma_addr_t *dh = (dma_addr_t *)dmahandle;
	pci_free_consistent(hw,size,vaddr,*dh);
}
void sis_pci_read_config_byte(unsigned short vendor, unsigned short device,int where,u8 *val)
{
	struct pci_dev *dev = NULL;
	dev = pci_find_device(vendor, device, dev);
	pci_read_config_byte(dev,where,val);
}
unsigned long sis_pciread(unsigned long vendor,unsigned long device,unsigned long offset,unsigned long mask)
{
	unsigned long check = vendor | (device<<16);
	unsigned long i;
	unsigned long result;
	unsigned long regVal;

	int found = 0;
	for(i=0x80000000;i<0x8000ff00;i+=0x100)
	{
		outl(i, 0xcf8);
		if(inl(0xcfc)==check)
		{
			found = 1;
			break;
		}
	}

	if(found)
	{
	//printk("find device %x\n",device);
	outl(i+offset, 0xcf8);
	regVal = inl(0xcfc);
	result=(unsigned long)regVal&mask;
	//printk("iobase %x\n",AudioBase);
	return(result);
	}
	return 0;
}
//void *sis_pci_alloc_consistent(size_t size, dma_addr_handle *dma_handle)
//{
//        void *ret;
//       int gfp = GFP_ATOMIC;
//        dma_addr_t * addr= (dma_addr_t *) dma_handle;

//        ret = (void *)__get_free_pages(gfp,get_order(size));
//        if(ret != NULL)  {
//                memset(ret,0,size);
//                *addr = virt_to_bus(ret);

//        }
//        return ret;

//}
//void sis_pci_free_consistent(size_t size,void *vaddr, dma_addr_handle * dma_handle)
//{
//        free_pages((unsigned long) vaddr, get_order(size));
//}
#endif
//void sis_pci_set_master(unsigned short vendor,unsigned short device)
//{
//	struct pci_dev *dev = NULL;

//	dev = pci_find_device(vendor,device,dev);
//	pci_set_master(dev);
//}
void sis_pci_set_master(void *pci_dev)
{
 	pci_set_master((struct pci_dev *)pci_dev);
}

/**********************************soundcore routine****************************/
//void sis_unregister_sound_synth(int unit)
//{
//	return unregister_sound_synth(unit);
//}
//void sis_unregister_sound_dsp(int unit)
//{
//	unregister_sound_dsp(unit);
//	kfree(audiofop);
//}
//void sis_unregister_sound_midi(int unit)
//{
//	return unregister_sound_midi(unit);
//}
//void sis_unregister_sound_mixer(int unit)
//{
//
//	unregister_sound_mixer(unit);
//	kfree(mixerfop);
//}
//void sis_unregister_sound_special(int unit)
//{
//	return unregister_sound_special(unit);
//}
//
//int sis_register_sound_synth(struct file_operations *fops,int dev)
//{
//	return register_sound_synth(fops,dev);
//}
//int sis_register_sound_midi(struct file_operations *fops,int dev)
//{
//	return register_sound_midi(fops,dev);
//}
//int sis_register_sound_special(struct file_operations *fops,int unit)
//{
//	return register_sound_special(fops,unit);
//}
//
//int sis_register_sound_mixer(struct file_operation_handle *fops, int dev)
//{
//	return register_sound_mixer(alloc_fop(fops,mixerfop),dev);
//}
//int sis_register_sound_dsp(struct file_operation_handle *fops, int dev)
//{
//	return register_sound_dsp(alloc_fop(fops,audiofop),dev);
//}
//
int
init_wrapper (void)
{
	wrapper_initialized = 1;

#if WAITQUEUE_DEBUG
        //printk("sis7019 : WAITQUEUE_DEBUG = 1 maybe result in errors with this driver\n");
	//printk("sis7019 : Stop to active this driver\n");
	return 0;
#endif

	return 1;
}
/*************************cli,save_flags,restore_flags***********/
static void sis_cli(void)
{
  cli();
}
static void sis_save_flags(unsigned long *flags)
{
	save_flags(*flags);
}
static void sis_restore_flags(unsigned long *flags)
{
	restore_flags(*flags);
}

///////////////////////ac97 set/get routine////////////////////////

size_t ac97_getsize(void)
{
	return sizeof(struct ac97_codec);
}
void * ac97_get_private(ac97_codec_handle * codec)
{
	struct ac97_codec * ac97 = (struct ac97_codec *) codec;
	return ac97->private_data;
}
int ac97_get_dev_mixer(ac97_codec_handle * codec)
{
	return ((struct ac97_codec *)codec)->dev_mixer;
}
void ac97_set_private(ac97_codec_handle *codec,void * private)
{
	((struct ac97_codec *)codec)->private_data = private;
}
void ac97_set_id(ac97_codec_handle *codec,int id)
{
	((struct ac97_codec *)codec)->id = id;
}
int ac97_get_id(ac97_codec_handle *codec)
{
	return ((struct ac97_codec *)codec)->id;
}
void ac97_set_codec_read(ac97_codec_handle *codec,phandle *p)
{
	ac97_read_t tmp = (ac97_read_t) p;
	((struct ac97_codec *)codec)->codec_read = tmp;
}
void ac97_set_codec_write(ac97_codec_handle *codec,phandle *p)
{
	ac97_write_t tmp = (ac97_write_t) p;
	((struct ac97_codec *)codec)->codec_write = tmp;
}
//int ac97_set_dev_mixer(ac97_codec_handle *codec,struct file_operation_handle *fp)
//{
//	struct ac97_codec * co = (struct ac97_codec *) codec;
//	if((co->dev_mixer = register_sound_mixer(alloc_fop(fp,mixerfop),-1))<0)
//	return 1;
//	else
//	return 0;
//}
int sis_ac97_mixer_ioctl(ac97_codec_handle *codec,unsigned int cmd,unsigned long arg)
{
	return ((struct ac97_codec *)codec)->mixer_ioctl((struct ac97_codec *)codec,cmd,arg);
}
u16 ac97_test(ac97_codec_handle * codec)
{
	return ((struct ac97_codec *)codec)->codec_read((struct ac97_codec *)codec,AC97_PCM_FRONT_DAC_RATE);
}
///////////////////////inode routine////////////////////////////////////
int inode_get_i_rdev(inode_handle *inode)
{
	return MINOR(((struct inode *)inode)->i_rdev);
}
////////////////////////mutex routine///////////////////////////////////
void sis_init_MUTEX(semaphore_handle *sem)
{
	init_MUTEX((struct semaphore *)sem);
}
void sis_up(struct semaphore * sem)
{
	up(sem);
}
void sis_down(struct semaphore *sem)
{
	down(sem);
}
///////////////////////current routine////////////////////////////////
static task_handle * sis_get_current(void)
{
	return (task_handle *) current;
}
static void sis_set_current_state(long flags)
{
	current->state = flags;
}
static int sis_got_signal(void)
{
	return signal_pending(current);
}
////////////////////////checking routine///////////////////////////
static int sis_chk_dma_addr_t(void)
{
//#ifdef CONFIG_HIGHMEM
//  	printk("sis : Using 64-bit DMA addresses\n");
// 	return 0;
//#endif
	if(sizeof(dma_addr_t)==sizeof(unsigned int))
	return 1;
	else
	return 0;
}
///////////////////////no use routine/////////////////////////////////
void dont_use_this_function(void)
{
	unsigned long flags;
	char k[32];
	wait_handle *wait;
	sis_cli();
	sis_save_flags(&flags);
	sis_restore_flags(&flags);
	wait = sis_declare_waitqueue();
	sis_remove_queue((wait_handle *)wait);
	sis_get_current();
	sis_got_signal();
	sis_set_current_state(0);
	strcpy(k,kernel_version);
	sis_chk_dma_addr_t();
}
//////////////////////////pci register driver routine////////////////////////
int sis_pci_register_driver(struct pci_driver_handle *pd)
{
	return pci_register_driver(alloc_pci_driver(pd));
}
void sis_pci_unregister_driver(struct pci_driver_handle *pd)
{
	pci_unregister_driver(pcidvr);
	kfree(pcidvr);
}
int sis_pci_module_init(struct pci_driver_handle *drv)
{
	
	return pci_module_init(alloc_pci_driver(drv));
}
//////////////////////////pci set/get routine/////////////////////////////////
void sis_pci_set_drvdata(void *ph,void *data)
{
	((struct pci_dev *)ph)->driver_data = data;
}
void * sis_pci_get_drvdata(void *ph)
{
	return ((struct pci_dev *)ph)->driver_data;
}
void sis_pci_set_dma_mask(void *ph,u64 mask)
{
	((struct pci_dev *)ph)->dma_mask = mask;
}
//////////////////////////netdev routine/////////////////////////////////////

void * sis_init_etherdev(void *dev,int priv_size)
{
	return (void *) init_etherdev((struct net_device*)dev,priv_size);
}
unsigned char * sis_netdev_get_dev_addr(void *dev)
{
	return ((struct net_device *)dev)->dev_addr;
}
void sis_netdev_set_last_rx(void *dev)
{
((struct net_device *)dev)->last_rx = jiffies;
}
void sis_netdev_set_trans_start(void *dev)
{
	((struct net_device *)dev)->trans_start = jiffies;
}
void sis_netdev_set_open(void *dev,void *open)
{
	((struct net_device *)dev)->open = (netdev_open_t) open;
}

void sis_netdev_set_stop(void *dev,void *stop)
{
	((struct net_device *)dev)->stop  = (netdev_stop_t) stop;
}
void sis_netdev_set_xmit(void *dev,void *xmit)
{
	((struct net_device *)dev)->hard_start_xmit = (netdev_hard_start_xmit_t) xmit;
}

void sis_netdev_set_mlist(void *dev,void *mlist)
{
	((struct net_device *)dev)->set_multicast_list	= (netdev_set_multicast_list_t) mlist;
}
void sis_netdev_set_maddr(void *dev,void *p)
{
	((struct net_device *)dev)->set_mac_address	= (netdev_set_mac_address_t) p;
}
void sis_netdev_set_ioctl(void *dev,void *p)
{
	((struct net_device *)dev)->do_ioctl	= (netdev_do_ioctl_t) p;
}
void sis_netdev_set_mtufun(void *dev,void *p)
{
	((struct net_device *)dev)->change_mtu	= (netdev_change_mtu_t) p;
}
void sis_netdev_set_gstats(void *dev,void *p)
{
	((struct net_device *)dev)->get_stats	= (netdev_get_stats_t) p;
}
void sis_netdev_set_gwstats(void *dev,void *p)
{
	((struct net_device *)dev)->get_wireless_stats	= (netdev_get_wireless_stats_t) p;
}
void * sis_netdev_get_priv(void *dev)
{
	return ((struct net_device *)dev)->priv;
}
void sis_netdev_set_priv(void *dev,void *priv)
{
	((struct net_device *)dev)->priv = priv;
}
unsigned short sis_netdev_get_flags(void *dev)
{
	return ((struct net_device *)dev)->flags;
}
void sis_netdev_set_flags(void *dev,unsigned short flags)
{
	((struct net_device *)dev)->flags = flags;
}
unsigned sis_netdev_get_mtu(void *dev)
{
	return ((struct net_device *)dev)->mtu;
}
void sis_netdev_set_mtu(void *dev,unsigned mtu)
{
	((struct net_device *)dev)->mtu = mtu;
}
unsigned int sis_netdev_get_irq(void *dev)
{
	return ((struct net_device *)dev)->irq;
}
void sis_netdev_set_irq(void *dev,unsigned int irq)
{
	((struct net_device *)dev)->irq = irq;
}
char * sis_netdev_get_name(void *dev)
{
	return ((struct net_device *)dev)->name;
}
void sis_netdev_set_name(void *dev,char *name)
{
	int i;
	for(i=0;i<IFNAMSIZ;i++)
	{
	if(i>sizeof(name))
		break;
	((struct net_device *)dev)->name[i] = name[i];
	}
}
unsigned long sis_netdev_get_base_addr(void *dev)
{
	return ((struct net_device *)dev)->base_addr;
}
void sis_netdev_set_base_addr(void *dev,unsigned long base_addr)
{
	((struct net_device *)dev)->base_addr = base_addr;
}
unsigned char sis_netdev_get_if_port(void *dev)
{
	return ((struct net_device *)dev)->base_addr;
}
void sis_netdev_set_if_port(void *dev,unsigned char if_port)
{
	((struct net_device *)dev)->if_port = if_port;
}
void sis_netif_start_queue(void *dev)
{
	netif_start_queue((struct net_device *)dev);
}
void sis_netif_stop_queue(void *dev)
{
	netif_stop_queue(dev);
}
//////////////////////////pcidev routine////////////////////////////
/*
unsigned char sis_pcidev_get_base_address0(void *dev)
{
	return (struct pci_dev *)dev->base_address[0];
}
void sis_pcidev_set_base_address0(void *dev,unsigned char base_address0)
{
	(struct pci_dev *)dev->base_address[0] = base_address[0];
}
*/
int sis_pci_request_regions(void * pdev, char * name)
{
	return(pci_request_regions(pdev,name));
}
void sis_pci_release_regions(void * pdev)
{
	pci_release_regions(pdev);
}
unsigned short sis_pcidev_get_vendor(void *dev)
{
	return ((struct pci_dev *)dev)->vendor;
}
void sis_pcidev_set_vendor(void *dev,unsigned short vendor)
{
	((struct pci_dev *)dev)->vendor = vendor;
}
unsigned short sis_pcidev_get_device(void *dev)
{
	return ((struct pci_dev *)dev)->device;
}
void sis_pcidev_set_device(void *dev,unsigned short device)
{
	((struct pci_dev *)dev)->device = device;
}
unsigned int sis_pcidev_get_devfn(void *dev)
{
	return ((struct pci_dev *)dev)->devfn;
}
void sis_pcidev_set_devfn(void *dev,unsigned int devfn)
{
	((struct pci_dev *)dev)->devfn = devfn;
}
unsigned int sis_pcidev_get_irq(void *dev)
{
	return ((struct pci_dev *)dev)->irq;
}
void sis_pcidev_set_irq(void *dev,unsigned int irq)
{
	((struct pci_dev *)dev)->irq = irq;
}
unsigned char sis_pcidev_bus_get_number(void *dev)
{
	return ((struct pci_dev *)dev)->bus->number;
}
void sis_pcidev_bus_set_number(void *dev,unsigned char number)
{
	((struct pci_dev *)dev)->bus->number = number;
}
//////////////////////////skbuff routine////////////////////////////
void *sis_dev_alloc_skb(unsigned int length)
{
	return (void *)(dev_alloc_skb(length));
}
unsigned char *sis_skb_put(void *skb, unsigned int len)
{
	return skb_put((struct sk_buff *)skb,len);
}
unsigned char *sis_skb_push(void *skb, unsigned int len)
{
	return skb_push((struct sk_buff *)skb,len);
}
unsigned char * sis_skb_pull(void *skb, unsigned int len)
{
	return skb_pull((struct sk_buff *)skb,len);
}
void sis_skb_reserve(void *skb, unsigned int len)
{
	skb_reserve((struct sk_buff *)skb,len);
}
void sis_skb_trim(void *skb, unsigned int len)
{
	skb_trim((struct sk_buff *)skb,len);
}
void * sis_skb_get_dev(void *skb)
{
	return (void *)(((struct sk_buff *)skb)->dev);
}
void sis_skb_set_dev(void *skb,void *dev)
{
	((struct sk_buff *)skb)->dev = (struct net_device *)dev;
}
unsigned short sis_skb_get_protocol(void *skb)
{
	return ((struct sk_buff *)skb)->protocol;
}
void sis_skb_set_protocol(void *skb,unsigned short protocol)
{
	((struct sk_buff *)skb)->protocol = protocol;
}
unsigned char sis_skb_get_ip_summed(void *skb)
{
	return ((struct sk_buff *)skb)->ip_summed;
}
void sis_skb_set_ip_summed(void *skb,unsigned char ip_summed)
{
	((struct sk_buff *)skb)->ip_summed = ip_summed;
}
unsigned int sis_skb_get_len(void *skb)
{
	return ((struct sk_buff *)skb)->len;
}
void sis_skb_set_len(void *skb,unsigned int len)
{
	((struct sk_buff *)skb)->len = len;
}
unsigned char * sis_skb_get_data(void *skb)
{
	return ((struct sk_buff *)skb)->data;
}
void sis_skb_set_data(void *skb,unsigned char *data)
{
	((struct sk_buff *)skb)->data = data;
}
//////////////////////////netif routine///////////////////////////////////////
#ifdef sis_netif
void sis_netif_mark_down(struct net_device *dev)
{
	netif_mark_down(dev);
}
void sis_netif_mark_up(struct net_device *dev)
{
	netif_mark_up(dev);
}
#endif
//////////////////////////file access routine////////////////////////////////
int sis_verify_area(int type,const void *addr,unsigned long size)
{
	return verify_area(type,addr,size);
}
//////////////////////////test routine///////////////////////////////////////
#define SIS_OP(deviceID)  \
void deviceID##_help(void)	\
{				\
	//printk("test success\n");   \	
} \
SIS_OP(sis);

void sis_tq_set(void * _tq)
{
	struct sistq * tq = (struct sistq *)_tq;
	sis_bh.routine = tq->routine;
	sis_bh.data = tq->data;
}
void sis_queue_task(void)
{
	queue_task(&sis_bh,&tq_immediate);	
}
//////////////////////////Add by Allen/2002/11/25//////////////////////////////
void sis_do_div(unsigned long long *n, unsigned long b) 
{     
//sunburst//2003/1/22//-----------------------
	unsigned long long *lltemp = n;
    unsigned long base;
    do_div(*lltemp, base);
//------------------------------------------------
    return;
}
//sunburst//2002//12/10
void sis_run_task_queue(void)
{
	run_task_queue(&tq_immediate);
}

//sunburst//2002/12/09
unsigned short sis_eth_type_trans(void *skb,void *dev)
{
	return eth_type_trans(skb,dev);
}
int sis_netif_rx(void *skb)
{
	return netif_rx(skb);
}
void sis_netif_device_attach(void *ndev)
{
	netif_device_attach(ndev);
}
int	sis_register_netdev(void *dev)
{
	return register_netdev(dev);
}
void sis_unregister_netdev(void *dev)
{
	unregister_netdev(dev);
}
int sis_netif_running(void *dev)
{
	return netif_running(dev);
}
//sunburst//2002/12/10
long long sis_do_gettimeofday(void)
{
	struct timeval tv;
	long long result;

	do_gettimeofday(&tv);
	result = tv.tv_usec + tv.tv_sec*1000000;
	return result;
}
/////////////////////card bus///////////////////////////////////////
#ifdef CARDBUS
int sis_register_driver(struct driver_operations_handle *dvrhandle)
{
	return register_driver(alloc_driver_operations(dvrhandle));	
}
void sis_unregister_driver(struct driver_operations *dvrhandle)
{
	int i;
	for(i=0;i<netcard_index;i++)
	{
		if(driver_op[i] == dvrhandle)
		unregister_driver(driver_op[i]);
	}
}
#endif
////////////////////////iwreq routine//////////////////////////////
char * sis_iwreq_get_name(void * wrq)
{
	return ((struct iwreq *)wrq)->u.name;
}
void sis_iwreq_set_name(void *wrq, char *name)
{
	//((struct iwreq *)wrq)->u.name = name;
	strncpy(((struct iwreq *)wrq)->u.name,name,sizeof(*name));
}

#if WIRELESS_EXT > 5
caddr_t sis_iwreq_essid_get_point(void * wrq)
{
	return ((struct iwreq *)wrq)->u.essid.pointer;
}
__u16 sis_iwreq_essid_get_length(void * wrq)
{
	return ((struct iwreq *)wrq)->u.essid.length;
}
__u16 sis_iwreq_essid_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.essid.flags;
}
void sis_iwreq_essid_set_point(void * wrq,caddr_t pointer)
{
	((struct iwreq *)wrq)->u.essid.pointer = pointer;
}
void sis_iwreq_essid_set_length(void * wrq,__u16 length)
{
	((struct iwreq *)wrq)->u.essid.length = length;
}
void sis_iwreq_essid_set_flags(void * wrq,__u16 flags)
{
	((struct iwreq *)wrq)->u.essid.flags = flags;
}
#endif //wireless_Ext >=6

#if WIRELESS_EXT > 2

__u32 sis_iwreq_freq_get_m(void * wrq)
{
	return ((struct iwreq *)wrq)->u.freq.m;
}
__u16 sis_iwreq_freq_get_e(void * wrq)
{
	return ((struct iwreq *)wrq)->u.freq.e;
}
__u8 sis_iwreq_freq_get_i(void * wrq)
{
	return ((struct iwreq *)wrq)->u.freq.i;
}
void sis_iwreq_freq_set_m(void * wrq,__u32 m)
{
	((struct iwreq *)wrq)->u.freq.m = m;
}
void sis_iwreq_freq_set_e(void * wrq,__u16 e)
{
	((struct iwreq *)wrq)->u.freq.e = e;
}
void sis_iwreq_freq_set_i(void * wrq,__u8 i)
{
	((struct iwreq *)wrq)->u.freq.i = i;
}
#endif //wireless_ext >= 3

caddr_t sis_iwreq_encoding_get_pointer(void * wrq)
{
	return ((struct iwreq *)wrq)->u.essid.pointer;
}
__u16 sis_iwreq_encoding_get_length(void * wrq)
{
	return ((struct iwreq *)wrq)->u.essid.length;
}
__u16 sis_iwreq_encoding_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.essid.flags;
}
void sis_iwreq_encoding_set_point(void * wrq,caddr_t pointer)
{
	((struct iwreq *)wrq)->u.essid.pointer = pointer;
}
void sis_iwreq_encoding_set_length(void * wrq,__u16 length)
{
	((struct iwreq *)wrq)->u.essid.length = length;
}
void sis_iwreq_encoding_set_flags(void * wrq,__u16 flags)
{
	((struct iwreq *)wrq)->u.essid.flags = flags;
}
caddr_t sis_iwreq_data_get_point(void * wrq)
{
	return ((struct iwreq *)wrq)->u.data.pointer;
}
__u16 sis_iwreq_data_get_length(void * wrq)
{
	return ((struct iwreq *)wrq)->u.data.length;
}
__u16 sis_iwreq_data_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.data.flags;
}
void sis_iwreq_data_set_point(void * wrq,caddr_t pointer)
{
	((struct iwreq *)wrq)->u.data.pointer = pointer;
}
void sis_iwreq_data_set_length(void * wrq,__u16 length)
{
	((struct iwreq *)wrq)->u.data.length = length;
}
void sis_iwreq_data_set_flags(void * wrq,__u16 flags)
{
	((struct iwreq *)wrq)->u.data.flags = flags;
}

#if WIRELESS_EXT > 7
__s32 sis_iwreq_bitrate_get_value(void * wrq)
{
	return ((struct iwreq *)wrq)->u.bitrate.value;
}
__u8 sis_iwreq_bitrate_get_fixed(void * wrq)
{
	return ((struct iwreq *)wrq)->u.bitrate.fixed;
}
#if WIRELESS_EXT > 8
__u8 sis_iwreq_bitrate_get_disabled(void * wrq)
{
	return ((struct iwreq *)wrq)->u.bitrate.disabled;
}
__u16 sis_iwreq_bitrate_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.bitrate.flags;
}
#endif
void sis_iwreq_bitrate_set_value(void * wrq, __s32 value)
{
	((struct iwreq *)wrq)->u.bitrate.value = value;
}
void sis_iwreq_bitrate_set_fixed(void * wrq, __u8 fixed)
{
	((struct iwreq *)wrq)->u.bitrate.fixed = fixed;
}
#if WIRELESS_EXT > 8
void sis_iwreq_bitrate_set_disabled(void * wrq, __u8 disabled)
{
	((struct iwreq *)wrq)->u.bitrate.disabled = disabled;
}
void sis_iwreq_bitrate_set_flags(void * wrq,  __u16 flags)
{
	((struct iwreq *)wrq)->u.bitrate.flags = flags;
}
#endif
#endif // wireless_ext >= 8

#if WIRELESS_EXT > 9
__s32 sis_iwreq_txpower_get_value(void * wrq)
{
	return ((struct iwreq *)wrq)->u.txpower.value;
}
__u8 sis_iwreq_txpower_get_fixed(void * wrq)
{
	return ((struct iwreq *)wrq)->u.txpower.fixed;
}
__u8 sis_iwreq_txpower_get_disabled(void * wrq)
{
	return ((struct iwreq *)wrq)->u.txpower.disabled;
}
__u16 sis_iwreq_txpower_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.txpower.flags;
}
void sis_iwreq_txpower_set_value(void * wrq, __s32 value)
{
	((struct iwreq *)wrq)->u.txpower.value = value;
}
void sis_iwreq_txpower_set_fixed(void * wrq, __u8 fixed)
{
	((struct iwreq *)wrq)->u.txpower.fixed = fixed;
}
void sis_iwreq_txpower_set_disabled(void * wrq, __u8 disabled)
{
	((struct iwreq *)wrq)->u.txpower.disabled = disabled;
}
void sis_iwreq_txpower_set_flags(void * wrq,  __u16 flags)
{
	((struct iwreq *)wrq)->u.txpower.flags = flags;
}
#endif

#if WIRELESS_EXT > 7
__s32 sis_iwreq_rts_get_value(void * wrq)
{
	return ((struct iwreq *)wrq)->u.rts.value;
}
__u8 sis_iwreq_rts_get_fixed(void * wrq)
{
	return ((struct iwreq *)wrq)->u.rts.fixed;
}
#if WIRELESS_EXT > 8
__u8 sis_iwreq_rts_get_disabled(void * wrq)
{
	return ((struct iwreq *)wrq)->u.rts.disabled;
}
__u16 sis_iwreq_rts_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.rts.flags;
}
#endif
void sis_iwreq_rts_set_value(void * wrq, __s32 value)
{
	((struct iwreq *)wrq)->u.rts.value = value;
}
void sis_iwreq_rts_set_fixed(void * wrq, __u8 fixed)
{
	((struct iwreq *)wrq)->u.rts.fixed = fixed;
}
#if WIRELESS_EXT > 8
void sis_iwreq_rts_set_disabled(void * wrq, __u8 disabled)
{
	((struct iwreq *)wrq)->u.rts.disabled = disabled;
}
void sis_iwreq_rts_set_flags(void * wrq,  __u16 flags)
{
	((struct iwreq *)wrq)->u.rts.flags = flags;
}
#endif

__s32 sis_iwreq_frag_get_value(void * wrq)
{
	return ((struct iwreq *)wrq)->u.frag.value;
}
__u8 sis_iwreq_frag_get_fixed(void * wrq)
{
	return ((struct iwreq *)wrq)->u.frag.fixed;
}
#if WIRELESS_EXT > 8
__u8 sis_iwreq_frag_get_disabled(void * wrq)
{
	return ((struct iwreq *)wrq)->u.frag.disabled;
}
__u16 sis_iwreq_frag_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.frag.flags;
}
#endif
void sis_iwreq_frag_set_value(void * wrq, __s32 value)
{
	((struct iwreq *)wrq)->u.frag.value = value;
}
void sis_iwreq_frag_set_fixed(void * wrq, __u8 fixed)
{
	((struct iwreq *)wrq)->u.frag.fixed = fixed;
}
#if WIRELESS_EXT > 8
void sis_iwreq_frag_set_disabled(void * wrq, __u8 disabled)
{
	((struct iwreq *)wrq)->u.frag.disabled = disabled;
}
void sis_iwreq_frag_set_flags(void * wrq,  __u16 flags)
{
	((struct iwreq *)wrq)->u.frag.flags = flags;
}
#endif
__s32 sis_iwreq_sens_get_value(void * wrq)
{
	return ((struct iwreq *)wrq)->u.sens.value;
}
__u8 sis_iwreq_sens_get_fixed(void * wrq)
{
	return ((struct iwreq *)wrq)->u.sens.fixed;
}
#if WIRELESS_EXT > 8
__u8 sis_iwreq_sens_get_disabled(void * wrq)
{
	return ((struct iwreq *)wrq)->u.sens.disabled;
}
__u16 sis_iwreq_sens_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.sens.flags;
}
#endif
void sis_iwreq_sens_set_value(void * wrq, __s32 value)
{
	((struct iwreq *)wrq)->u.sens.value = value;
}
void sis_iwreq_sens_set_fixed(void * wrq, __u8 fixed)
{
	((struct iwreq *)wrq)->u.sens.fixed = fixed;
}
#if WIRELESS_EXT > 8
void sis_iwreq_sens_set_disabled(void * wrq, __u8 disabled)
{
	((struct iwreq *)wrq)->u.sens.disabled = disabled;
}
void sis_iwreq_sens_set_flags(void * wrq,  __u16 flags)
{
	((struct iwreq *)wrq)->u.sens.flags = flags;
}
#endif

#endif //wireless_ext >= 8

#if WIRELESS_EXT > 10
__s32 sis_iwreq_retry_get_value(void * wrq)
{
	return ((struct iwreq *)wrq)->u.retry.value;
}
__u8 sis_iwreq_retry_get_fixed(void * wrq)
{
	return ((struct iwreq *)wrq)->u.retry.fixed;
}
__u8 sis_iwreq_retry_get_disabled(void * wrq)
{
	return ((struct iwreq *)wrq)->u.retry.disabled;
}
__u16 sis_iwreq_retry_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.retry.flags;
}
void sis_iwreq_retry_set_value(void * wrq, __s32 value)
{
	((struct iwreq *)wrq)->u.retry.value = value;
}
void sis_iwreq_retry_set_fixed(void * wrq, __u8 fixed)
{
	((struct iwreq *)wrq)->u.retry.fixed = fixed;
}
void sis_iwreq_retry_set_disabled(void * wrq, __u8 disabled)
{
	((struct iwreq *)wrq)->u.retry.disabled = disabled;
}
void sis_iwreq_retry_set_flags(void * wrq,  __u16 flags)
{
	((struct iwreq *)wrq)->u.retry.flags = flags;
}
#endif

__s32 sis_iwreq_power_get_value(void * wrq)
{
	return ((struct iwreq *)wrq)->u.power.value;
}
__u8 sis_iwreq_power_get_fixed(void * wrq)
{
	return ((struct iwreq *)wrq)->u.power.fixed;
}
__u8 sis_iwreq_power_get_disabled(void * wrq)
{
	return ((struct iwreq *)wrq)->u.power.disabled;
}
__u16 sis_iwreq_power_get_flags(void * wrq)
{
	return ((struct iwreq *)wrq)->u.power.flags;
}
void sis_iwreq_power_set_value(void * wrq, __s32 value)
{
	((struct iwreq *)wrq)->u.power.value = value;
}
void sis_iwreq_power_set_fixed(void * wrq, __u8 fixed)
{
	((struct iwreq *)wrq)->u.power.fixed = fixed;
}
void sis_iwreq_power_set_disabled(void * wrq, __u8 disabled)
{
	((struct iwreq *)wrq)->u.power.disabled = disabled;
}
void sis_iwreq_power_set_flags(void * wrq,  __u16 flags)
{
	((struct iwreq *)wrq)->u.power.flags = flags;
}

#if WIRELESS_EXT > 8
__u32 sis_iwreq_get_mode(void * wrq)
{
	return ((struct iwreq *)wrq)->u.mode;
}
void sis_iwreq_set_mode(void * wrq, __u32 mode)
{
	((struct iwreq *)wrq)->u.mode = mode;
}
#endif //wireless_Ext >= 9

sa_family_t sis_iwreq_ap_addr_get_sa_family(void * wrq)
{
	return ((struct iwreq *)wrq)->u.ap_addr.sa_family;
}
void sis_iwreq_ap_addr_set_sa_family(void * wrq, sa_family_t sa_family)
{
	((struct iwreq *)wrq)->u.ap_addr.sa_family = sa_family;
}
char * sis_iwreq_ap_addr_get_sa_data(void * wrq)
{
	return ((struct iwreq *)wrq)->u.ap_addr.sa_data;
}
void sis_iwreq_ap_addr_set_sa_data(void * wrq, char * sa_data)
{
	//((struct iwreq *)wrq)->u.ap_addr.sa_data = sa_data;
	memcpy(((struct iwreq *)wrq)->u.ap_addr.sa_data,sa_data,sizeof(*sa_data));
}
void sis_iwreq_ap_addr_set_sa_data_item(void * wrq, int i, unsigned char x)
{
	((struct iwreq *)wrq)->u.ap_addr.sa_data[i] = x;
}

int sis_getsizeof_iw_range(void)
{
	return sizeof(struct iw_range);
}
//////////////////////////////module routine////////////////////
void sis_set_module_owner(void *ndev)
{
	SET_MODULE_OWNER((struct net_device *)ndev);
}
////////////////////////////////////////////////////////////////
void sis_set_rx(unsigned long count)
{
	sis_status.rx_packets = count;
}
void sis_set_tx(unsigned long count)
{
	sis_status.tx_packets = count;
}
void sis_set_rxdrop(unsigned long count)
{
	sis_status.rx_dropped = count;
}
void sis_set_rxerr(unsigned long count)
{
	sis_status.rx_errors = count;
}
void sis_set_txerr(unsigned long count)
{
	sis_status.tx_errors = count;
}
void sis_set_rxcrcerr(unsigned long count)
{
	sis_status.rx_crc_errors = count;
}
void sis_set_rxbytes(unsigned long count)
{
	sis_status.rx_bytes = count;
}
void sis_set_txbytes(unsigned long count)
{
	sis_status.tx_bytes = count;
}
void *sis_get_status(void)
{
	return (void *)&sis_status;
}
/////////////////////////////////////////////////////////////
void sis_dev_kfree_skb_irq(void *skb)
{
	dev_kfree_skb_irq(skb);
}
void sis_dev_kfree_skb_any(void *skb)
{
	dev_kfree_skb_irq(skb);
}
//////////////////////////////////////////////////////////
/*
static int __init sis_init_module(void)
{
	return sis160_init_module();
}
static void __exit sis_cleanup_module(void)
{
	sis160_cleanup_module();
}
*/
//module_init(sis_init_module);
//module_exit(sis_cleanup_module);
